VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SmartForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
'Filename:  SmartForm
'Author:    Steve Brown
'Date:      5-18-1998
'Purpose:   Smart forms can be referenced in your
'           standard VB forms to make them remeber
'           their size and position between application
'           runs.
'
'To Use:
'           1.  Create a private object in the
'               form's (General)(Declarations):
'
'               Private WithEvents sf As SmartForm
'
'           2.  Add these lines of code to the
'               Form_Load() event:
'
'                   Set sf = New SmartForm
'                   Set sf.Form = Me
'
'           3.  Add this line of code to the Resize event:
'
'                   sf.Resize
'
'           4.  And finally, this line goes in the Unload event:
'
'                   Set sf = Nothing
'
'           NOTE:   You can place error messages in the
'                   sf_ErrorMessage event if you want to.
'
'Updates:   None
'


Option Explicit

'Private variables
Private mForm As Object
Private mLeft As Long
Private mTop As Long
Private mWidth As Long
Private mHeight As Long
Private mWS As Integer

Public Event ErrorMessage(Message As String)







Private Sub GetSettings()
    Dim mAppName As String
    
    'Set the variable to the EXE filename
    mAppName = App.EXEName
    
    With mForm
        If .Name <> "" Then
            mLeft = Val(GetSetting(mAppName, _
                    .Name, "Left", .Left))
            mTop = Val(GetSetting(mAppName, _
                    .Name, "Top", .Top))
            mWidth = Val(GetSetting(mAppName, _
                    .Name, "Width", .Width))
            mHeight = Val(GetSetting(mAppName, _
                    .Name, "Height", .Height))
            mWS = Val(GetSetting(mAppName, .Name, _
                    "WindowState", .WindowState))
                    
            'Size the form
            .WindowState = mWS
            .Move mLeft, mTop, mWidth, mHeight
        Else
            'Trigger an ErrorMessage event
            RaiseEvent ErrorMessage("You must set the form object!")
        End If
    End With
End Sub


Public Sub Resize()
    'All we need to do is save the form's
    'coordinates
    SaveSettings
End Sub






Private Sub SaveSettings()
    Dim mAppName As String
    
    'Set the variable to the EXE filename
    mAppName = App.EXEName
    
    'We can only save information if we know
    'the app name and the form name...
    With mForm
        If .Name <> "" Then
            SaveSetting mAppName, .Name, _
                    "WindowState", Str$(.WindowState)
            
            If .WindowState = vbNormal Then
                SaveSetting mAppName, .Name, _
                        "Left", Str$(.Left)
                SaveSetting mAppName, .Name, _
                        "Top", Str$(.Top)
                SaveSetting mAppName, .Name, _
                        "Width", Str$(.Width)
                SaveSetting mAppName, .Name, _
                        "Height", Str$(.Height)
            End If
        Else
            'Trigger an ErrorMessage event
            RaiseEvent ErrorMessage("You must set the form object!")
        End If
    End With
End Sub




Public Property Get Form() As Object
    Set Form = mForm
End Property

Public Property Set Form(ByVal vNewValue As Object)
    'Create a reference to the actual
    'form object
    Set mForm = vNewValue
    
    'Get the saved coordinates
    GetSettings
    
    'Do the first resize
    Resize
End Property

Private Sub Class_Terminate()
    'Save the form's settings
    SaveSettings
    
    'Destroy the local object reference
    Set mForm = Nothing
End Sub
